#!/bin/sh

LEXFILE=`mktemp`
CFILE=`mktemp`
AOUT=`mktemp`

( echo -e '
C	[\xc3]
D	[\x61]
%{
int yywrap(void) { return 1; }

static int f1 = 0;
static int f2 = 0;
%}
%%
{C}     { if(!f1) printf("<ok1,0x%x>",(int)(unsigned char)*yytext); f1 += 1; }
{D}     { if(!f2) printf("<ok2,0x%x>",(int)(unsigned char)*yytext); f2 += 1; }
<<EOF>> { return !!(f1==1 && f2==1); }
%%
int main() {
    return !yylex();
}
'
) > ${LEXFILE}
./flex -o${CFILE} ${LEXFILE}\
&& gcc -x c ${CFILE} -o ${AOUT}\
&& echo -e '\xc3\x61' | ${AOUT}
result=$?
rm -f ${LEXFILE} ${CFILE} ${AOUT}

if [ "x$result" = "x0" ]; then
	echo "passed"
	true
else
	echo "failed!"
	false
fi
